<template>
  <div id="app">
    <navigation-bar/>
    <router-view/>
    
    <!--<tag-list-creator v-model="this.tags"/>-->
  </div>
</template>

<script>
import NavigationBar from '@/components/NavigationBar'
import UploadsPanel from '@/components/UploadsPanel'
import CompetitionSummaryPanel from '@/components/CompetitionSummaryPanel'
import CompetitionCreationView from '@/views/CompetitionCreationView'
import TagListCreator from '@/components/TagListCreator'

import MockedBackendManager from '@/interop/MockedBackendManager'
import backend from '@/backend-manager'

import Competition from '@/models/Competition'
import Submission from '@/models/Submission'
import Tag from '@/models/Tag'

export default {
    name: 'app',
    created: function() {
      //var newManager = new MockedBackendManager(this.models, [])
      //backend.setInstance(newManager)
      //this.handler = newManager.getCompetitionCreationManager()
      //setTimeout(() => this.upload = true, 7500)
    },
    components: {
        NavigationBar: NavigationBar,
        UploadsPanel: UploadsPanel,
        CompetitionCreationView: CompetitionCreationView,
        CompetitionSummaryPanel: CompetitionSummaryPanel,
        TagListCreator: TagListCreator
    },

    data: function() {
      var handlerClass = function() {
          this.callback = function(files) {
              console.log('Callback successfully called with this fileset: ' + files)
          }
      };

      return {
        files: {},
        handler: new handlerClass(),
        upload: false,
        tags: [],
        
        // Models for the mocked backend
        models: [
          new Competition('id1', 'Title', new Date(), 25,
                    [new Tag('fire', 'Hot'), new Tag('c-sharp', 'C#')],
                    '', 'description', 'https://www.w3schools.com/w3css/img_lights.jpg'),
          
          new Competition('id2', 'Title2', new Date(), 10, [], '', 'description 2',
                'https://www.w3schools.com/w3css/img_lights.jpg'),

          new Competition('id3', 'Title3', new Date(), 13, [], '', 'description 3', ''),
          
          new Submission('id4', 'user', 'id1', 'completed', new Date(), {}, 5, 12, 15),
          new Submission('id5', 'user', 'id1', 'completed', new Date(0), {}, 1, 13, 89),
          new Submission('id6', 'user', 'id2', 'completed', new Date(), {}, 1, 12, 100)
        ]
      }
    }
}
</script>
